\section{Service Mesh}
A service mesh is a dedicated infrastructure layer for handling service-to-service communication. It’s responsible for the reliable delivery of requests through the complex topology of services that comprise a modern, cloud native application. In practice, the service mesh is typically implemented as an array of lightweight network proxies that are deployed alongside application code, without the application needing to be aware.

\begin{figure}[h!]
  \center
  \includegraphics[width=\textwidth]{microservices}
  \caption{History of Microservices}
\end{figure}

\paragraph{Microservice principles}
\begin{enumerate}
	\item Deployment Independence - updates to an individual microservice have no negative impact to any other component of the system. Optimized for replacement.
	\item Organized around business Capabilites
	\item Products not Projects
	\item API Focused
	\item Smart endpoints and dumb pipes
	\item Decentralized Governance
	\item Decentralized Data Management
	\item Infrastructure Automation (IaC)
	\item Design for failure
	\item Evolutionary design
replacement 
\end{enumerate}